﻿using UnityEngine;
using System.Collections;

public class Timer : MonoBehaviour {

    public delegate void VFN();

    float m_timerValue = 0;
    float m_timerDuration;
    bool m_running = false;

    public float value { get { return m_timerValue; } }
    public float duration { get { return m_timerDuration; } }

    public bool running { get { return m_running; } }

    VFN m_cb;

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {

        if (m_running)
        {
            if (m_timerValue < m_timerDuration)
                m_timerValue += Time.deltaTime * 1000;
            else
            {
                m_timerValue = 0;
                m_running = false;

                if (m_cb != null)
                    m_cb();
                else
                    Debug.Log("WARNING NULL");
            }
        }
	}

    public void Start(float a_duration)
    {
        m_timerDuration = a_duration;
        m_timerValue = 0;

        m_running = true;
    }

    public void Stop()
    {
        m_timerValue = 0;

        m_running = false;
    }

    public void PushCallback(VFN a_cb)
    {
        m_cb += a_cb;
    }
}
